/*
 *
 * system monitor usage plugin
 *
 * ver 1.0
 *
 * @author : b0unc3
 * @ver	   : 1.0
 *
 */

#include <hildon-status-bar-lib/hildon-status-bar-item.h>
#include<gtk/gtk.h>

#include <stdio.h>
#include <sys/statfs.h>
#include <errno.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>

#define ICON_PLACE	"/usr/share/icons/hicolor/scalable/hildon/"
#define LOW_ICON	ICON_PLACE"hd-25.png"
#define MEDIUM_ICON	ICON_PLACE"hd-50.png"
#define MEDIUM2_ICON	ICON_PLACE"hd-75.png"
#define FULL_ICON	ICON_PLACE"hd-full.png"
#define CPU_ICON	ICON_PLACE"cpu.png"
#define MEM_ICON	ICON_PLACE"mem.png"
#define DISK_ICON	ICON_PLACE"slash.png"
#define MMC_ICON	ICON_PLACE"mmc.png"
#define WRONG_ICON	ICON_PLACE"hd-wrong.png"
#define WIFI_ICON	ICON_PLACE"wifi.png"

#define CPUFILE "/proc/stat"
#define MEMFILE "/proc/meminfo"
#define WIFIFILE "/proc/net/wireless"

#define USER 0
#define NICE 1
#define SYSTEM 2
#define IDLE 3

#define MAX_DIGITS_CHARS 32
#define MAX_READ_CHARS 4096

#define HILDON_STATUS_BAR_MENU_Y_POS 60

void *system_monitor_initialize(HildonStatusBarItem *item, GtkWidget **button);
void system_monitor_destroy(void *data);
void system_monitor_update(void *data, gint value1,gint value2, const gchar *str);
int system_monitor_get_priority(void *data);

struct _SystemMonitorPlugin
{
	HildonStatusBarItem *item;
	GtkWidget *view;
	GtkWidget *button0;
	GtkWidget *button;
	GdkPixbuf *pixbuf_25;
	GdkPixbuf *pixbuf_50;
	GdkPixbuf *pixbuf_75;
	GdkPixbuf *pixbuf_curr;
	GdkPixbuf *pixbuf_full;
	GdkPixbuf *pixbuf_wrong;
	GdkPixbuf *pixbuf_cpu;
	GdkPixbuf *pixbuf_mem;
	GdkPixbuf *pixbuf_memi;
	GdkPixbuf *pixbuf_disk;
	GdkPixbuf *pixbuf_diski;
	GdkPixbuf *pixbuf_cpui;
	GdkPixbuf *pixbuf_wireless;
	GdkPixbuf *pixbuf_wifi;
	GdkPixbuf *pixbuf_mmc;
	GdkPixbuf *pixbuf_mmci;
	GtkWidget *frame;
	GtkWidget *icon;
	GtkWidget *icon_oth;
	GtkWidget *icon_wi;
	GtkWidget *button1;
	GtkWidget *s_frame;
	GtkWidget *icon1;
	GtkWidget *icon2;
	guint timeout_times;
	GtkWidget *icon3;
	GtkWidget *icon4;
	guint timeout_id;

	/* menu */
	GtkWidget *menu;
	GtkWidget *menu_separator;
	GtkWidget *menu_details;
	GtkWidget *menu_about;
	/* end */
};

typedef struct _SystemMonitorPlugin SystemMonitorPlugin;

static unsigned int times1[4];

void system_monitor_entry(HildonStatusBarPluginFn_st *fn)
{
	if ( fn == NULL ) {
		return;
	}
	fn->initialize=system_monitor_initialize;
	fn->destroy=system_monitor_destroy;
	fn->update=system_monitor_update;
	fn->get_priority=system_monitor_get_priority;
}

unsigned int *GetTimes(void) {
	static unsigned int times[4];
	char tmp[5];
	char str[80];
	FILE *file;
	
	file = fopen(CPUFILE, "r");
	fgets(str, 80, file);
	sscanf(str, "%s %u %u %u %u", tmp, &times[0], &times[1], &times[2], &times[3]);
	fclose(file);
	return times;
}

static gboolean set_pix(gpointer data)
{
	FILE *m;
	gboolean is_mounted = FALSE;
	unsigned int total;
	double load;
	int i;
	unsigned int *times;
	long long size;
	long long avail;
	float percent;
	float used;
	const char *path;
	struct statfs buf;
	FILE *f;
	int memfree = 0;
	int memavail = 0;
	int swapfree = 0;
	int swapavail= 0;
	int totavail = 0;
	int free = 0;
	int memtot = 0;
	char read_buffer[MAX_READ_CHARS];
		 
	SystemMonitorPlugin *smp = (SystemMonitorPlugin *)data;

	path="/";
	if ( statfs(path, &buf) != 0) {
		g_error("error!!");
	}
	
	size = ((long long)buf.f_blocks * (long long)buf.f_bsize ) / 1024 / 1024;
	avail = ( (long long)buf.f_bavail * (long long)buf.f_bsize ) / 1024 / 1024;
	percent = ( ( (float)100 / (float)size ) * (float)avail );
	used = 100 - percent;
						

	/*root */
	if ( used > 0 && used < 25 ) {
		gdk_pixbuf_composite(smp->pixbuf_25,smp->pixbuf_diski,0,0,16,40,0,0,1,1,GDK_INTERP_NEAREST, 255);
		gdk_pixbuf_composite(smp->pixbuf_disk,smp->pixbuf_diski,0,20,16,20,0,26,1,1,GDK_INTERP_NEAREST, 255);
		gtk_image_set_from_pixbuf(GTK_IMAGE(smp->icon), smp->pixbuf_diski);
	} else if ( used > 25 && used < 50 ) { 
		gdk_pixbuf_composite(smp->pixbuf_50,smp->pixbuf_diski,0,0,16,40,0,0,1,1,GDK_INTERP_NEAREST, 255);
		gdk_pixbuf_composite(smp->pixbuf_disk,smp->pixbuf_diski,0,20,16,20,0,26,1,1,GDK_INTERP_NEAREST, 255);
		gtk_image_set_from_pixbuf(GTK_IMAGE(smp->icon), smp->pixbuf_diski);
	} else if ( used > 50 && used < 75 ) {
		gdk_pixbuf_composite(smp->pixbuf_75,smp->pixbuf_diski,0,0,16,40,0,0,1,1,GDK_INTERP_NEAREST, 255);
		gdk_pixbuf_composite(smp->pixbuf_disk,smp->pixbuf_diski,0,20,16,20,0,26,1,1,GDK_INTERP_NEAREST, 255);
		gtk_image_set_from_pixbuf(GTK_IMAGE(smp->icon), smp->pixbuf_diski);
	}
       	else {
		gdk_pixbuf_composite(smp->pixbuf_full,smp->pixbuf_diski,0,0,16,40,0,0,1,1,GDK_INTERP_NEAREST, 255);
		gdk_pixbuf_composite(smp->pixbuf_disk,smp->pixbuf_diski,0,20,16,20,0,26,1,1,GDK_INTERP_NEAREST, 255);
		gtk_image_set_from_pixbuf(GTK_IMAGE(smp->icon), smp->pixbuf_diski);
	}
	path = "/media/mmc1";

	/* mount mmc verify */
	m = fopen("/proc/mounts","r");
 	while ( fgets(read_buffer,MAX_READ_CHARS, m) != NULL) {
		if ( strstr(read_buffer,"mmc") != NULL ) {
			is_mounted = TRUE;
		}
	}
	fclose(m);

	if ( !is_mounted ) {
	/*	gdk_pixbuf_composite(smp->pixbuf_25,smp->pixbuf_mmci, 0,0,16,40,0,0,1,1,GDK_INTERP_NEAREST, 255);*/
		gdk_pixbuf_composite(smp->pixbuf_wrong,smp->pixbuf_mmci, 0,0,16,40,0,0,1,1,GDK_INTERP_NEAREST, 255);
		gdk_pixbuf_composite(smp->pixbuf_mmc,smp->pixbuf_mmci,0,20,16,20,0,26,1,1,GDK_INTERP_NEAREST, 255);
		gtk_image_set_from_pixbuf(GTK_IMAGE(smp->icon_oth), smp->pixbuf_mmci);
	} else {
	if ( statfs(path,&buf) != 0 ) {
		g_error("error!!");
	/*dk_pixbuf_composite(smp->pixbuf_wrong,smp->pixbuf_mmci, 0,0,16,40,0,0,1,1,GDK_INTERP_NEAREST, 255);*/
	}

	size = ((long long)buf.f_blocks * (long long)buf.f_bsize ) / 1024 / 1024;
	avail = ( (long long)buf.f_bavail * (long long)buf.f_bsize ) / 1024 / 1024;
	percent = ( ( (float)100 / (float)size ) * (float)avail );
	used = 100 - percent;

	/*mmc*/
	if ( used > 0 && used < 45 ) {
		gdk_pixbuf_composite(smp->pixbuf_25,smp->pixbuf_mmci, 0,0,16,40,0,0,1,1,GDK_INTERP_NEAREST, 255);
  		gdk_pixbuf_composite(smp->pixbuf_mmc,smp->pixbuf_mmci, 0,20,16,20,0,26,1,1,GDK_INTERP_NEAREST, 255);
		gtk_image_set_from_pixbuf(GTK_IMAGE(smp->icon_oth), smp->pixbuf_mmci);
	} else if ( used > 45 && used < 65 ) {
		gdk_pixbuf_composite(smp->pixbuf_50,smp->pixbuf_mmci, 0,0,16,40,0,0,1,1,GDK_INTERP_NEAREST, 255);
		gdk_pixbuf_composite(smp->pixbuf_mmc,smp->pixbuf_mmci ,0,20,16,20,0,26,1,1,GDK_INTERP_NEAREST, 255);
		gtk_image_set_from_pixbuf(GTK_IMAGE(smp->icon_oth), smp->pixbuf_mmci);
	} else if ( used > 65 && used < 80 ) {
		gdk_pixbuf_composite(smp->pixbuf_75,smp->pixbuf_mmci, 0,0,16,40,0,0,1,1,GDK_INTERP_NEAREST, 255);
		gdk_pixbuf_composite(smp->pixbuf_mmc,smp->pixbuf_mmci ,0,20,16,20,0,26,1,1,GDK_INTERP_NEAREST, 255);
		gtk_image_set_from_pixbuf(GTK_IMAGE(smp->icon_oth), smp->pixbuf_mmci);
	}
	else {
		gdk_pixbuf_composite(smp->pixbuf_full,smp->pixbuf_mmci, 0,0,16,40,0,0,1,1,GDK_INTERP_NEAREST, 255);
		gdk_pixbuf_composite(smp->pixbuf_mmc,smp->pixbuf_mmci,0,20,16,20,0,26,1,1,GDK_INTERP_NEAREST, 255);
		gtk_image_set_from_pixbuf(GTK_IMAGE(smp->icon_oth), smp->pixbuf_mmci);
	}
	}
	times = GetTimes();
	for(i=0;i<4;i++)
		times1[i] = times[i] - times1[i];
	
	total=0;
	for(i=0;i<4;i++)
		total += times1[i];

	load = (double)times1[IDLE] * 100.0 /(double)total;
	load = 100.0 - load;
	gdk_pixbuf_composite(smp->pixbuf_25,smp->pixbuf_cpui,0,0,16,40,0,0,1,1,GDK_INTERP_NEAREST, 255);
	gdk_pixbuf_composite(smp->pixbuf_cpu,smp->pixbuf_cpui,0,25,16,15,0,25,1,1,GDK_INTERP_NEAREST, 255);
	gtk_image_set_from_pixbuf(GTK_IMAGE(smp->icon2), smp->pixbuf_cpui);
	if ( load > 0 && load < 25 ) {
		gdk_pixbuf_composite(smp->pixbuf_25,smp->pixbuf_cpui,0,0,16,40,0,0,1,1,GDK_INTERP_NEAREST, 255);
		gdk_pixbuf_composite(smp->pixbuf_cpu,smp->pixbuf_cpui,0,25,16,15,0,25,1,1,GDK_INTERP_NEAREST, 255);
		gtk_image_set_from_pixbuf(GTK_IMAGE(smp->icon2), smp->pixbuf_cpui);
	} else if ( load > 25 && load < 55 ) {
		gdk_pixbuf_composite(smp->pixbuf_50,smp->pixbuf_cpui,0,0,16,40,0,0,1,1,GDK_INTERP_NEAREST, 255);
		gdk_pixbuf_composite(smp->pixbuf_cpu,smp->pixbuf_cpui,0,25,16,15,0,25,1,1,GDK_INTERP_NEAREST, 255);
		gtk_image_set_from_pixbuf(GTK_IMAGE(smp->icon2), smp->pixbuf_cpui);
	} else if ( load > 55 && load < 85 ) {
		gdk_pixbuf_composite(smp->pixbuf_75,smp->pixbuf_cpui,0,0,16,40,0,0,1,1,GDK_INTERP_NEAREST, 255);
		gdk_pixbuf_composite(smp->pixbuf_cpu,smp->pixbuf_cpui,0,25,16,15,0,25,1,1,GDK_INTERP_NEAREST, 255);
		gtk_image_set_from_pixbuf(GTK_IMAGE(smp->icon2), smp->pixbuf_cpui);
	} else if ( load > 85 && load < 102) {
		gdk_pixbuf_composite(smp->pixbuf_full,smp->pixbuf_cpui,0,0,16,40,0,0,1,1,GDK_INTERP_NEAREST, 255);
		gdk_pixbuf_composite(smp->pixbuf_cpu,smp->pixbuf_cpui,0,25,16,15,0,25,1,1,GDK_INTERP_NEAREST, 255);
		gtk_image_set_from_pixbuf(GTK_IMAGE(smp->icon2), smp->pixbuf_cpui);
	}
	memcpy(times1, GetTimes(),sizeof(unsigned int) *4);
	
	f = fopen(MEMFILE,"r");
	while ( fgets(read_buffer,MAX_READ_CHARS, f) != NULL) {
		if ( strncmp(read_buffer, "MemFree",7) == 0 ) {
			 sscanf(read_buffer + 13,"%d",&memfree);
		} else if ( strncmp(read_buffer,"SwapFree",8) == 0 ) {
			sscanf(read_buffer + 13 , "%d", &swapfree);
		} else if ( strncmp(read_buffer,"MemTotal",8) == 0 ) {
			sscanf(read_buffer + 13 , "%d" , &memavail);
		} else if ( strncmp(read_buffer,"SwapTotal",9) == 0 ) {
			sscanf(read_buffer + 13 , "%d" , &swapavail);
		}
	}
	fclose(f);

	totavail = ( memavail / 1024 ) + ( swapavail / 1024);
	memfree = memfree / 1024;
	swapfree = swapfree / 1024;
	total = memfree + swapfree;
	memtot = totavail - total;
	free = memtot * 100 / totavail;

	gdk_pixbuf_composite(smp->pixbuf_25,smp->pixbuf_memi,0,0,16,40,0,0,1,1,GDK_INTERP_NEAREST, 255);
	gdk_pixbuf_composite(smp->pixbuf_mem,smp->pixbuf_memi,0,25,16,15,0,25,1,1,GDK_INTERP_NEAREST, 255);
	gtk_image_set_from_pixbuf(GTK_IMAGE(smp->icon1), smp->pixbuf_memi);
	
	if ( free > 0 && free < 25 ) {
		gdk_pixbuf_composite(smp->pixbuf_25,smp->pixbuf_memi,0,0,16,40,0,0,1,1,GDK_INTERP_NEAREST, 255);
		gdk_pixbuf_composite(smp->pixbuf_mem,smp->pixbuf_memi,0,25,16,15,0,25,1,1,GDK_INTERP_NEAREST, 255);
		gtk_image_set_from_pixbuf(GTK_IMAGE(smp->icon1), smp->pixbuf_memi);
	} else if ( free > 25 && free < 65 ) {
		gdk_pixbuf_composite(smp->pixbuf_50,smp->pixbuf_memi,0,0,16,40,0,0,1,1,GDK_INTERP_NEAREST, 255);
		gdk_pixbuf_composite(smp->pixbuf_mem,smp->pixbuf_memi,0,25,16,15,0,25,1,1,GDK_INTERP_NEAREST, 255);
		gtk_image_set_from_pixbuf(GTK_IMAGE(smp->icon1), smp->pixbuf_memi);
	} else if ( free > 65 && free < 90 ) {
		gdk_pixbuf_composite(smp->pixbuf_75,smp->pixbuf_memi,0,0,16,40,0,0,1,1,GDK_INTERP_NEAREST, 255);
		gdk_pixbuf_composite(smp->pixbuf_mem,smp->pixbuf_memi,0,25,16,15,0,25,1,1,GDK_INTERP_NEAREST, 255);
		gtk_image_set_from_pixbuf(GTK_IMAGE(smp->icon1), smp->pixbuf_memi);
	} else if ( free > 90 ) {
		gdk_pixbuf_composite(smp->pixbuf_full,smp->pixbuf_memi,0,0,16,40,0,0,1,1,GDK_INTERP_NEAREST, 255);
		gdk_pixbuf_composite(smp->pixbuf_mem,smp->pixbuf_memi,0,25,16,15,0,25,1,1,GDK_INTERP_NEAREST, 255);
		gtk_image_set_from_pixbuf(GTK_IMAGE(smp->icon1), smp->pixbuf_memi);
	}

	/* wifi link */
	int link=-1;
	f = fopen("/proc/net/wireless","r");
	while ( fgets(read_buffer,MAX_READ_CHARS,f) != NULL) {
		if ( strstr(read_buffer,"wlan0:") != NULL ) {
			sscanf(read_buffer + 13,"%d",&link);
		}
	}
	fclose(f);

	if ( link == -1 || link == 0 ) {
		gdk_pixbuf_composite(smp->pixbuf_wrong,smp->pixbuf_wifi, 0,0,16,40,0,0,1,1,GDK_INTERP_NEAREST, 255);
		gdk_pixbuf_composite(smp->pixbuf_wireless,smp->pixbuf_wifi,0,25,16,15,0,25,1,1,GDK_INTERP_NEAREST, 255);;
		gtk_image_set_from_pixbuf(GTK_IMAGE(smp->icon_wi), smp->pixbuf_wifi);
	} else {
	if ( link > 0 && link < 25 ) {
		gdk_pixbuf_composite(smp->pixbuf_25,smp->pixbuf_wifi, 0,0,16,40,0,0,1,1,GDK_INTERP_NEAREST, 255);
		gdk_pixbuf_composite(smp->pixbuf_wireless,smp->pixbuf_wifi,0,25,16,15,0,25,1,1,GDK_INTERP_NEAREST, 255);;
		gtk_image_set_from_pixbuf(GTK_IMAGE(smp->icon_wi), smp->pixbuf_wifi);
	} else if ( link > 25 && link < 50 ) {
		gdk_pixbuf_composite(smp->pixbuf_50,smp->pixbuf_wifi, 0,0,16,40,0,0,1,1,GDK_INTERP_NEAREST, 255);
		gdk_pixbuf_composite(smp->pixbuf_wireless,smp->pixbuf_wifi,0,25,16,15,0,25,1,1,GDK_INTERP_NEAREST, 255);;
		gtk_image_set_from_pixbuf(GTK_IMAGE(smp->icon_wi), smp->pixbuf_wifi);
	} else if ( link > 50 && link < 75 ) {
		gdk_pixbuf_composite(smp->pixbuf_75,smp->pixbuf_wifi, 0,0,16,40,0,0,1,1,GDK_INTERP_NEAREST, 255);
		gdk_pixbuf_composite(smp->pixbuf_wireless,smp->pixbuf_wifi,0,25,16,15,0,25,1,1,GDK_INTERP_NEAREST, 255);;
		gtk_image_set_from_pixbuf(GTK_IMAGE(smp->icon_wi), smp->pixbuf_wifi);
	} else if ( link > 75 ) {
		gdk_pixbuf_composite(smp->pixbuf_full,smp->pixbuf_wifi, 0,0,16,40,0,0,1,1,GDK_INTERP_NEAREST, 255);
		gdk_pixbuf_composite(smp->pixbuf_wireless,smp->pixbuf_wifi,0,25,16,15,0,25,1,1,GDK_INTERP_NEAREST, 255);;
		gtk_image_set_from_pixbuf(GTK_IMAGE(smp->icon_wi), smp->pixbuf_wifi);
	}
	}
	
	return TRUE;

}
/* menu */

static void show_details(GtkMenuItem *item, gpointer data)
{ 
}

static void show_about(GtkMenuItem *item, gpointer data)
{ 
	GtkWidget *dialog;
	GtkWidget *label;
	GtkWidget *button_ok,*button_cancel;
	
	dialog = gtk_dialog_new();
	button_ok = gtk_dialog_add_button(GTK_DIALOG(dialog), "Ok", 0);
	button_cancel = gtk_dialog_add_button(GTK_DIALOG(dialog), "Cancel", 1);

	label = gtk_label_new("ABOUT");
	gtk_container_add (GTK_CONTAINER (GTK_DIALOG(dialog)->vbox),label);	
}

static pos_menu(GtkMenu *menu, gint *x, gint *y,
		         gboolean *in, gpointer data)
{
	GtkAllocation *a, *ma;
	GtkWidget *toplevel;
	gint tx, ty;
	
	g_return_if_fail(x && y);
	g_return_if_fail(data);
	g_return_if_fail(GTK_IS_WIDGET(((SystemMonitorPlugin*)(data))->item));
	
	a = &(GTK_WIDGET(((SystemMonitorPlugin*)(data))->item)->allocation);

	gtk_widget_realize(GTK_WIDGET(menu));
	ma = &GTK_WIDGET(menu)->allocation;
	
	toplevel = gtk_widget_get_toplevel(GTK_WIDGET(((SystemMonitorPlugin*)(data))->item));
	
	if(GTK_WIDGET_TOPLEVEL(toplevel))
	{
		gdk_window_get_position(toplevel->window, &tx, &ty);
		*x = (tx + a->x + a->width) - ma->width;
	}
	*y = HILDON_STATUS_BAR_MENU_Y_POS;
}

	
static void show_menu(GtkWidget *widget, gpointer data){
	SystemMonitorPlugin *smp = (SystemMonitorPlugin *)data;

	if (GTK_IS_MENU(smp->menu)) { /* is this a memory leak??? */
	    gtk_widget_destroy(smp->menu_about);
	    gtk_widget_destroy(smp->menu_separator);
	    gtk_widget_destroy(smp->menu_details);
	    gtk_widget_destroy(smp->menu);
    	}
	smp->menu = gtk_menu_new();

	/* Details */
	smp->menu_details = gtk_menu_item_new_with_label("Details");
	/*gtk_menu_popup(GTK_MENU(smp->menu),NULL,NULL,pos_menu,data,1,gtk_get_current_event_time());*/
	gtk_menu_shell_append(GTK_MENU_SHELL(smp->menu),smp->menu_details);
	g_signal_connect(G_OBJECT(smp->menu_details),
			   "activate",
			   G_CALLBACK(show_details),
			   smp);

	/* Separator */
        smp->menu_separator = gtk_separator_menu_item_new();
        gtk_menu_shell_append(GTK_MENU_SHELL(smp->menu), smp->menu_separator);
	/* About */
	smp->menu_about = gtk_menu_item_new_with_label("About");
	gtk_menu_shell_append(GTK_MENU_SHELL(smp->menu),smp->menu_about);
	g_signal_connect(G_OBJECT(smp->menu_about),
			   "activate",
			   G_CALLBACK(show_about),
			   smp);

	gtk_widget_show_all(smp->menu);
	
	gtk_menu_shell_select_first(GTK_MENU_SHELL(smp->menu), TRUE);
	    
	gtk_menu_popup(GTK_MENU(smp->menu), NULL, NULL, pos_menu, data, 1, NULL); /*gtk_get_current_event_time());*/
}
/* end  */


void *system_monitor_initialize(HildonStatusBarItem *item, GtkWidget **button)
{
	GtkWidget *image = NULL;
	GError *error = NULL;

	SystemMonitorPlugin *smp = g_new0(SystemMonitorPlugin, 1);

	smp->item=item;
	smp->frame = gtk_hbox_new(FALSE,2);
	smp->icon = gtk_image_new_from_pixbuf(NULL);
	smp->icon_oth = gtk_image_new_from_pixbuf(NULL);
	smp->icon1 = gtk_image_new_from_pixbuf(NULL);
	smp->icon2 = gtk_image_new_from_pixbuf(NULL);
	smp->icon_wi = gtk_image_new_from_pixbuf(NULL);
	smp->button = gtk_toggle_button_new();
	smp->button1 = gtk_toggle_button_new();
	*button = smp->button0 = gtk_toggle_button_new();
	
	gtk_container_add(GTK_CONTAINER(smp->frame),smp->icon);
	gtk_container_add(GTK_CONTAINER(smp->frame),smp->icon_oth);
	gtk_container_add(GTK_CONTAINER(smp->frame),smp->icon1);
	gtk_container_add(GTK_CONTAINER(smp->frame),smp->icon2);
	gtk_container_add(GTK_CONTAINER(smp->frame),smp->icon_wi);
	gtk_container_add(GTK_CONTAINER(*button),smp->frame);

	/* in buona sostanza button e' il conteiner principale
	 * qui andrebbe data una funzione alla pressione.
	 * */
	
	smp->pixbuf_25 = gdk_pixbuf_new_from_file(LOW_ICON,&error);
	smp->pixbuf_50 = gdk_pixbuf_new_from_file(MEDIUM_ICON,&error);
	smp->pixbuf_75 = gdk_pixbuf_new_from_file(MEDIUM2_ICON,&error);
	smp->pixbuf_full = gdk_pixbuf_new_from_file(FULL_ICON,&error);
	smp->pixbuf_wrong = gdk_pixbuf_new_from_file(WRONG_ICON,&error);
	smp->pixbuf_curr = gdk_pixbuf_new_from_file(FULL_ICON,&error);
	smp->pixbuf_mem = gdk_pixbuf_new_from_file(MEM_ICON,&error);
	smp->pixbuf_memi = gdk_pixbuf_new_from_file(MEDIUM2_ICON,&error);
	smp->pixbuf_disk = gdk_pixbuf_new_from_file(DISK_ICON,&error);
	smp->pixbuf_diski = gdk_pixbuf_new_from_file(LOW_ICON,&error);
	smp->pixbuf_mmc = gdk_pixbuf_new_from_file(MMC_ICON,&error);
	smp->pixbuf_mmci = gdk_pixbuf_new_from_file(LOW_ICON,&error);
	smp->pixbuf_cpu = gdk_pixbuf_new_from_file(CPU_ICON,&error);
	smp->pixbuf_cpui = gdk_pixbuf_new_from_file(LOW_ICON,&error);
	smp->pixbuf_wireless = gdk_pixbuf_new_from_file(WIFI_ICON,&error);
	smp->pixbuf_wifi = gdk_pixbuf_new_from_file(LOW_ICON,&error);

	gdk_pixbuf_composite(smp->pixbuf_cpu,smp->pixbuf_cpui,0,25,16,15,0,25,1,1,GDK_INTERP_NEAREST, 255);
	gdk_pixbuf_composite(smp->pixbuf_mem,smp->pixbuf_memi,0,25,16,15,0,25,1,1,GDK_INTERP_NEAREST, 255);
	gdk_pixbuf_composite(smp->pixbuf_disk,smp->pixbuf_diski,0,20,16,20,0,26,1,1,GDK_INTERP_NEAREST, 255);
	gdk_pixbuf_composite(smp->pixbuf_mmc,smp->pixbuf_mmci,0,20,16,20,0,26,1,1,GDK_INTERP_NEAREST, 255);
	gdk_pixbuf_composite(smp->pixbuf_wireless,smp->pixbuf_wifi,0,25,16,15,0,25,1,1,GDK_INTERP_NEAREST, 255);;
	
	gtk_image_set_from_pixbuf(GTK_IMAGE(smp->icon), smp->pixbuf_diski);
	gtk_image_set_from_pixbuf(GTK_IMAGE(smp->icon_oth),smp->pixbuf_mmci);
	gtk_image_set_from_pixbuf(GTK_IMAGE(smp->icon1), smp->pixbuf_memi);
	gtk_image_set_from_pixbuf(GTK_IMAGE(smp->icon2), smp->pixbuf_cpui);
	gtk_image_set_from_pixbuf(GTK_IMAGE(smp->icon_wi), smp->pixbuf_wifi);

 
	/* menu */
	g_signal_connect(G_OBJECT(smp->button0), "clicked",
			 G_CALLBACK(show_menu),
                     	 smp);
	/* end */

	gtk_widget_show_all(smp->button);

	smp->timeout_id = gtk_timeout_add(1000, set_pix, smp);

	return (void *)smp;
}

void system_monitor_update(void *data, gint value1, gint value2, const gchar *str)
{
	if ( !data ) {
		return;
	}
	SystemMonitorPlugin *smp = (SystemMonitorPlugin *)data;

	if ( value1 == 0 ) {
		gtk_widget_destroy(GTK_WIDGET(smp->item));
	} else {
		gtk_widget_show_all(smp->button0);
	}

	return;
}

void system_monitor_destroy(void *data)
{
	SystemMonitorPlugin *smp = (SystemMonitorPlugin *)data;
	if (!data) {
		return;
	}

	/* MAYBE TO FIX */
	g_object_unref(smp->pixbuf_25);
	g_object_unref(smp->pixbuf_50);
	g_object_unref(smp->pixbuf_75);
	g_object_unref(smp->pixbuf_full);
	g_object_unref(smp->pixbuf_curr);
	g_object_unref(smp->pixbuf_disk);
	g_object_unref(smp->pixbuf_diski);
	g_object_unref(smp->pixbuf_mmc);
	g_object_unref(smp->pixbuf_mmci);
	g_object_unref(smp->pixbuf_mem);
	g_object_unref(smp->pixbuf_memi);
	g_object_unref(smp->pixbuf_cpu);
	g_object_unref(smp->pixbuf_cpui);
	g_source_remove(smp->timeout_id);

	g_free(data);
}

gint system_monitor_get_priority(void *data)
{
	return 23;
}

